const sh0rk = @import("./sh0rk.zig");
const w4 = @import("./wasm4.zig");
const sprites = @import("./sprites.zig");

pub fn draw() void {
    w4.m.colors.* = .{
        ._0 = .p0,
        ._1 = .p1,
        ._2 = .p2,
        ._3 = .p3,
    };

    w4.blitSub(
        &sprites.frame,
        0,
        128,
        8,
        8,
        0,
        0,
        sprites.frame_width,
        w4.BlitFlags{.two_bits = true},
    );

    w4.blitSub(
        &sprites.frame,
        152,
        128,
        8,
        8,
        16,
        0,
        sprites.frame_width,
        w4.BlitFlags{.two_bits = true},
    );

    w4.blitSub(
        &sprites.frame,
        0,
        136,
        8,
        8,
        0,
        8,
        sprites.frame_width,
        w4.BlitFlags{.two_bits = true},
    );

    w4.blitSub(
        &sprites.frame,
        152,
        144,
        8,
        8,
        16,
        8,
        sprites.frame_width,
        w4.BlitFlags{.two_bits = true},
    );

    w4.blitSub(
        &sprites.frame,
        152,
        136,
        8,
        8,
        16,
        8,
        sprites.frame_width,
        w4.BlitFlags{.two_bits = true},
    );

    w4.blitSub(
        &sprites.frame,
        0,
        144,
        8,
        8,
        0,
        8,
        sprites.frame_width,
        w4.BlitFlags{.two_bits = true},
    );

    w4.blitSub(
        &sprites.frame,
        0,
        152,
        8,
        8,
        0,
        16,
        sprites.frame_width,
        w4.BlitFlags{.two_bits = true},
    );

    w4.blitSub(
        &sprites.frame,
        152,
        152,
        8,
        8,
        16,
        16,
        sprites.frame_width,
        w4.BlitFlags{.two_bits = true},
    );

    var i: u8 = 0;
    while (i < 18) {
        defer i += 1;

        w4.blitSub(
            &sprites.frame,
            (i * 8) + 8,
            128,
            8,
            8,
            8,
            0,
            sprites.frame_width,
            w4.BlitFlags{.two_bits = true},
        );

        w4.blitSub(
            &sprites.frame,
            (i * 8) + 8,
            136,
            8,
            8,
            8,
            8,
            sprites.frame_width,
            w4.BlitFlags{.two_bits = true},
        );

        w4.blitSub(
            &sprites.frame,
            (i * 8) + 8,
            144,
            8,
            8,
            8,
            8,
            sprites.frame_width,
            w4.BlitFlags{.two_bits = true},
        );

        w4.blitSub(
            &sprites.frame,
            (i * 8) + 8,
            152,
            8,
            8,
            8,
            16,
            sprites.frame_width,
            w4.BlitFlags{.two_bits = true},
        );
    }
}